ALTER TABLE project_scm ADD COLUMN external_browse_url TEXT;
ALTER TABLE project_scm ADD COLUMN browse_text TEXT;
ALTER TABLE project_scm ADD COLUMN access_text TEXT;

ALTER TABLE tracker_extra_field ADD COLUMN use_auto_assign BOOLEAN;
ALTER TABLE tracker_extra_field ALTER COLUMN use_auto_assign SET DEFAULT FALSE;
UPDATE tracker_extra_field SET use_auto_assign=false;

ALTER TABLE tracker_extra_field_element ADD COLUMN auto_assign_to INTEGER;
ALTER TABLE tracker_extra_field_element ALTER COLUMN auto_assign_to SET DEFAULT 100;
UPDATE tracker_extra_field_element SET auto_assign_to=100;
ALTER TABLE tracker_extra_field_element ADD 
	CONSTRAINT userid_fk FOREIGN KEY (auto_assign_to) REFERENCES "user"(user_id);

CREATE TABLE tracker_extra_field_element_transition (
tracker_extra_field_element_transition_id SERIAL PRIMARY KEY,
element_id INTEGER NOT NULL CONSTRAINT elementid_fk 
	REFERENCES tracker_extra_field_element(element_id) ON DELETE CASCADE,
to_element_id INTEGER NOT NULL CONSTRAINT toelementid_fk
        REFERENCES tracker_extra_field_element(element_id) ON DELETE CASCADE
);

CREATE TABLE tracker_extra_field_element_transition_role (
tracker_extra_field_element_transition_id INTEGER NOT NULL CONSTRAINT elementtransitionid_fk 
	REFERENCES tracker_extra_field_element_transition(tracker_extra_field_element_transition_id) ON DELETE CASCADE,
role_id INTEGER NOT NULL CONSTRAINT roleid_fk
        REFERENCES role(role_id) ON DELETE CASCADE,
PRIMARY KEY (tracker_extra_field_element_transition_id,role_id)
);

CREATE TABLE tracker_extra_field_element_transition_field (
tracker_extra_field_element_transition_id INTEGER NOT NULL CONSTRAINT elementtransitionid_fk 
	REFERENCES tracker_extra_field_element_transition(tracker_extra_field_element_transition_id) ON DELETE CASCADE,
required_tracker_extra_field_id INTEGER NOT NULL CONSTRAINT requiredtrackerextrafieldid_fk
        REFERENCES tracker_extra_field(tracker_extra_field_id) ON DELETE CASCADE,
PRIMARY KEY (tracker_extra_field_element_transition_id,required_tracker_extra_field_id)
);


