<?php

/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version $Id$
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('lib/core/Filesystem.php');
require_once('lib/core/FilesystemPeer.php');
require_once('plugins/docman/lib/DocmanFile.php');
require_once('plugins/docman/lib/DocmanFilePeer.php');
require_once('plugins/docman/lib/DocmanFileVersion.php');
require_once('plugins/docman/lib/DocmanFileVersionPeer.php');
require_once('plugins/docman/lib/DocmanFolder.php');
require_once('plugins/docman/lib/DocmanFolderPeer.php');
require_once('lib/exceptions/PermissionDeniedException.php');
require_once('Validator.php');

$project = GFUrl::getUrl()->getProject();

if (!Session::getSession()->isLoggedIn()) {
	throw new PermissionDeniedException();
}

$dfv = DocmanFileVersionPeer::retrieveByPK($_REQUEST['docman_file_version_id']);
if (!is_object($dfv) 
	|| $dfv->getDocmanFile()->getDocmanFolder()->getProjectId()!=$project->getProjectId()
	|| !$dfv->userCanDelete()) {
	throw new PermissionDeniedException();
}

$subdir=$dfv->getDocmanFile()->getDocmanFolder()->getDocmanFolderId();
$fileid=$dfv->getDocmanFile()->getDocmanFileId();
//if this is the only version of this file, delete the entire file
if (count($dfv->getDocmanFile()->getDocmanFileVersions()) < 2) {
	$dfv->getDocmanFile()->delete();
	GFUrl::redirect(GFUrl::getUrl()->projectURL($project,'','docman','',array('subdir'=>$subdir,'feedback'=>'Successfully Deleted')));
} else {
	//delete just this version
	$dfv->delete();
	GFUrl::redirect(GFUrl::getUrl()->projectURL($project,'DocmanFileEdit','docman','',array('id'=>$fileid,'feedback'=>'Successfully Deleted')));
}
$con->commit();
?>
