<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('plugins/docman/lib/DocmanFolderPeer.php');
require_once('plugins/docman/lib/DocmanFileVersionPeer.php');
require_once('lib/core/FilesystemPeer.php');
require_once('exceptions/PermissionDeniedException.php');

$session = Session::getSession();
$Lang = $session->getLanguage();
$project=GFUrl::getUrl()->getProject();

require_once('plugins/docman/lib/html/DocmanAdminTemplate.php');
$theme = new DocmanAdminTemplate();

$id = $_REQUEST['id'];
if (isset($_REQUEST['return_to'])) {
	$return_to = 'admin';
} else {
	$return_to = '';
}
$file = DocmanFilePeer::retrieveByPK($id);
if (!is_object($file) || $file->getDocmanFolder()->getProject()->getProjectId() != $project->getProjectId()) {
	throw new PermissionDeniedException();
}
$subdir = $file->getDocmanFolderId();
$versions = sizeof($file->getDocmanFileVersions());

$params = array(
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	'action' => isset($action) ? $action : '',
	'title' => $Lang->getText('Docman.EditPageTitle'),
	'project' => $project
			);

$folder_id = ( isset($_POST['folder_id']) ? htmlspecialchars($_POST['folder_id']) : $file->getDocmanFolderId() );
$description = ( isset($_POST['description']) ? htmlspecialchars($_POST['description']) : $file->getDescription() );
$is_locked = ( isset($_POST['is_locked']) ? $_POST['is_locked'] : $file->getIsLocked() );
$changes = ( isset($_POST['changes']) ? htmlspecialchars($_POST['changes']) : '' );
include('forms/DocmanFileEdit-tpl.php');

?>
