<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a ScmModule and saves it to the 
// database
//
require_once('plugins/scm/lib/ScmModule.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

$project = GFUrl::getUrl()->getProject();

if ($_SERVER['REQUEST_METHOD'] != 'POST' || !isset($_POST['id']) || !$project->getPermission()->isAdmin()) {
	throw new PermissionDeniedException();
}


$Lang = Language::getSessLang();

try {
	if (!isset($_POST['module']) || empty($_POST['module'])) {
		$errors = array($Lang->getText('CodeSearchModule.EmptyModule', array($CODE_SEARCH_MODULE_NAME)));
		throw new InvalidDataException($errors);
	}

	$stmt = Propel::getConnection()->prepareStatement('UPDATE code_search_module SET module=? WHERE code_search_module_id=?');
	$stmt->setString(1, Validator::sanitizeString($_POST['module']));
	$stmt->setInt(2, Validator::sanitizeInt($_POST['id']));
	$stmt->executeQuery();

	$url = GFUrl::getUrl();
	GFUrl::redirect($url->currentBaseURL('CodeSearchModuleBrowse'), array('feedback' => $Lang->getText('CodeSearchModule.EditFeedback', array($CODE_SEARCH_MODULE_NAME))));
} catch (InvalidDataException $ex) {
	$errors = $ex->getErrors();		// attach object errors to validation errors
	$feedback = '* '.implode('<br />* ', $errors);
	include('CodeSearchModuleEdit.php');
}

?>
