<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'tracker_item' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.tracker.lib.map
 */
class TrackerItemMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.tracker.lib.map.TrackerItemMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("tracker_item");
		$tMap->setPhpName("TrackerItem");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("tracker_item_tracker_item_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("TRACKER_ITEM_ID", "TrackerItemId", "int", CreoleTypes::INTEGER, true);
		$tMap->addForeignKey("TRACKER_ID", "TrackerId", "int", CreoleTypes::INTEGER, "tracker" , "TRACKER_ID", true);
		$tMap->addColumn("STATUS_ID", "StatusId", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("PRIORITY", "Priority", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addForeignKey("SUBMITTED_BY", "SubmittedBy", "int", CreoleTypes::INTEGER, "user" , "USER_ID", true);
		$tMap->addColumn("OPEN_DATE", "OpenDate", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("CLOSE_DATE", "CloseDate", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("SUMMARY", "Summary", "string", CreoleTypes::VARCHAR, true, null);
		$tMap->addColumn("DETAILS", "Details", "string", CreoleTypes::VARCHAR, true, null);
		$tMap->addColumn("LAST_MODIFIED_DATE", "LastModifiedDate", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("LAST_MODIFIED_BY", "LastModifiedBy", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("SORT_ORDER", "SortOrder", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("PARENT_ID", "ParentId", "int", CreoleTypes::INTEGER, false, null);
				
    }
}
