<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';
 

// (on-demand) include_once 'plugins/tracker/lib/Tracker.php';
// (on-demand) include_once 'plugins/tracker/lib/TrackerPeer.php';

include_once 'plugins/tracker/lib/TrackerItemPeer.php';

/**
 * Base class that represents a row from the 'tracker_item' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to TrackerItem class. 
 * 
 * @package plugins.tracker.lib 
 */
abstract class BaseTrackerItem extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var TrackerItemPeer
	 */
	protected static $peer;

	/**
	 * The value for the tracker_item_id field.
	 * @var int	  
	 */
	protected $tracker_item_id;	

	/**
	 * The value for the tracker_id field.
	 * @var int	  
	 */
	protected $tracker_id;	

	/**
	 * The value for the status_id field.
	 * @var int	  
	 */
	protected $status_id = 1;	

	/**
	 * The value for the priority field.
	 * @var int	  
	 */
	protected $priority = 3;	

	/**
	 * The value for the submitted_by field.
	 * @var int	  
	 */
	protected $submitted_by;	

	/**
	 * The value for the open_date field.
	 * @var int	  
	 */
	protected $open_date = -1;	

	/**
	 * The value for the close_date field.
	 * @var int	  
	 */
	protected $close_date;	

	/**
	 * The value for the summary field.
	 * @var string	  
	 */
	protected $summary;	

	/**
	 * The value for the details field.
	 * @var string	  
	 */
	protected $details;	

	/**
	 * The value for the last_modified_date field.
	 * @var int	  
	 */
	protected $last_modified_date = -1;	

	/**
	 * The value for the last_modified_by field.
	 * @var int	  
	 */
	protected $last_modified_by = 0;	

	/**
	 * The value for the sort_order field.
	 * @var int	  
	 */
	protected $sort_order = 0;	

	/**
	 * The value for the parent_id field.
	 * @var int	  
	 */
	protected $parent_id = 0;	
  
	/**
	 * Get the TrackerItemId column value.
	 *  
	 * @return int	  
	 */
	public function getTrackerItemId()
	{
		return $this->tracker_item_id;
	}


	/**
	 * Set the value of `tracker_item_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setTrackerItemId($v)
	{
		if ($this->tracker_item_id !== $v) {
			$this->tracker_item_id = $v;
			$this->modifiedColumns[] = TrackerItemPeer::TRACKER_ITEM_ID;
		}
			
		  // update associated CruisecontrolDefect		  
		  if ($this->collCruisecontrolDefects !== null) {
			  for ($i=0,$size=count($this->collCruisecontrolDefects); $i < $size; $i++) {
				  $this->collCruisecontrolDefects[$i]->setTrackerItemId($v);
			  }
		  }
			  	
		  // update associated TrackerItemScmCommit		  
		  if ($this->collTrackerItemScmCommits !== null) {
			  for ($i=0,$size=count($this->collTrackerItemScmCommits); $i < $size; $i++) {
				  $this->collTrackerItemScmCommits[$i]->setTrackerItemId($v);
			  }
		  }
			  	
		  // update associated TrackerExtraFieldData		  
		  if ($this->collTrackerExtraFieldDatas !== null) {
			  for ($i=0,$size=count($this->collTrackerExtraFieldDatas); $i < $size; $i++) {
				  $this->collTrackerExtraFieldDatas[$i]->setTrackerItemId($v);
			  }
		  }
			  	
		  // update associated TrackerMyQueue		  
		  if ($this->collTrackerMyQueues !== null) {
			  for ($i=0,$size=count($this->collTrackerMyQueues); $i < $size; $i++) {
				  $this->collTrackerMyQueues[$i]->setTrackerItemId($v);
			  }
		  }
			  	
		  // update associated TrackerItemAssignee		  
		  if ($this->collTrackerItemAssignees !== null) {
			  for ($i=0,$size=count($this->collTrackerItemAssignees); $i < $size; $i++) {
				  $this->collTrackerItemAssignees[$i]->setTrackerItemId($v);
			  }
		  }
			  	
		  // update associated TrackerItemMessage		  
		  if ($this->collTrackerItemMessages !== null) {
			  for ($i=0,$size=count($this->collTrackerItemMessages); $i < $size; $i++) {
				  $this->collTrackerItemMessages[$i]->setTrackerItemId($v);
			  }
		  }
			  	
		  // update associated TrackerItemRelation		  
		  if ($this->collTrackerItemRelationsRelatedByRelatedTrackerItemId !== null) {
			  for ($i=0,$size=count($this->collTrackerItemRelationsRelatedByRelatedTrackerItemId); $i < $size; $i++) {
				  $this->collTrackerItemRelationsRelatedByRelatedTrackerItemId[$i]->setRelatedTrackerItemId($v);
			  }
		  }
			  	
		  // update associated TrackerItemRelation		  
		  if ($this->collTrackerItemRelationsRelatedByTrackerItemId !== null) {
			  for ($i=0,$size=count($this->collTrackerItemRelationsRelatedByTrackerItemId); $i < $size; $i++) {
				  $this->collTrackerItemRelationsRelatedByTrackerItemId[$i]->setTrackerItemId($v);
			  }
		  }
			  	
		  // update associated TrackerItemDuplicate		  
		  if ($this->collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId !== null) {
			  for ($i=0,$size=count($this->collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId); $i < $size; $i++) {
				  $this->collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId[$i]->setDuplicateOfTrackerItemId($v);
			  }
		  }
			  	
		  // update associated TrackerItemDuplicate		  
		  if ($this->collTrackerItemDuplicatesRelatedByTrackerItemId !== null) {
			  for ($i=0,$size=count($this->collTrackerItemDuplicatesRelatedByTrackerItemId); $i < $size; $i++) {
				  $this->collTrackerItemDuplicatesRelatedByTrackerItemId[$i]->setTrackerItemId($v);
			  }
		  }
			  	
		  // update associated TrackerItemTime		  
		  if ($this->collTrackerItemTimes !== null) {
			  for ($i=0,$size=count($this->collTrackerItemTimes); $i < $size; $i++) {
				  $this->collTrackerItemTimes[$i]->setTrackerItemId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the TrackerId column value.
	 *  
	 * @return int	  
	 */
	public function getTrackerId()
	{
		return $this->tracker_id;
	}


	/**
	 * Set the value of `tracker_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setTrackerId($v)
	{
		if ($this->tracker_id !== $v) {
			$this->tracker_id = $v;
			$this->modifiedColumns[] = TrackerItemPeer::TRACKER_ID;
		}
			
		if ($this->aTracker !== null && $this->aTracker->getTrackerId() !== $v) {
			$this->aTracker = null;
		}
			
	}

  
	/**
	 * Get the StatusId column value.
	 *  
	 * @return int	  
	 */
	public function getStatusId()
	{
		return $this->status_id;
	}


	/**
	 * Set the value of `status_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setStatusId($v)
	{
		if ($this->status_id !== $v || $v === 1) {
			$this->status_id = $v;
			$this->modifiedColumns[] = TrackerItemPeer::STATUS_ID;
		}
				
	}

  
	/**
	 * Get the Priority column value.
	 *  
	 * @return int	  
	 */
	public function getPriority()
	{
		return $this->priority;
	}


	/**
	 * Set the value of `priority` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setPriority($v)
	{
		if ($this->priority !== $v || $v === 3) {
			$this->priority = $v;
			$this->modifiedColumns[] = TrackerItemPeer::PRIORITY;
		}
				
	}

  
	/**
	 * Get the SubmittedBy column value.
	 *  
	 * @return int	  
	 */
	public function getSubmittedBy()
	{
		return $this->submitted_by;
	}


	/**
	 * Set the value of `submitted_by` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setSubmittedBy($v)
	{
		if ($this->submitted_by !== $v) {
			$this->submitted_by = $v;
			$this->modifiedColumns[] = TrackerItemPeer::SUBMITTED_BY;
		}
			
		if ($this->aUser !== null && $this->aUser->getUserId() !== $v) {
			$this->aUser = null;
		}
			
	}


	/**
	 * Get the [optionally formatted] `open_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getOpenDate($format = 'Y-m-d H:i:s')
	{
		if ($this->open_date === null || $this->open_date === '') {
			return null;
		} elseif (!is_int($this->open_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->open_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of open_date as date/time value: " . var_export($this->open_date, true));
			}
		} else {
			$ts = $this->open_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `open_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setOpenDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for open_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->open_date !== $ts || $ts === -1) {
			$this->open_date = $ts;
			$this->modifiedColumns[] = TrackerItemPeer::OPEN_DATE;
		}
		
	}


	/**
	 * Get the [optionally formatted] `close_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getCloseDate($format = 'Y-m-d H:i:s')
	{
		if ($this->close_date === null || $this->close_date === '') {
			return null;
		} elseif (!is_int($this->close_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->close_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of close_date as date/time value: " . var_export($this->close_date, true));
			}
		} else {
			$ts = $this->close_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `close_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setCloseDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for close_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->close_date !== $ts || $ts === -1) {
			$this->close_date = $ts;
			$this->modifiedColumns[] = TrackerItemPeer::CLOSE_DATE;
		}
		
	}

  
	/**
	 * Get the Summary column value.
	 *  
	 * @return string	  
	 */
	public function getSummary()
	{
		return $this->summary;
	}


	/**
	 * Set the value of `summary` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setSummary($v)
	{
		if ($this->summary !== $v) {
			$this->summary = $v;
			$this->modifiedColumns[] = TrackerItemPeer::SUMMARY;
		}
				
	}

  
	/**
	 * Get the Details column value.
	 *  
	 * @return string	  
	 */
	public function getDetails()
	{
		return $this->details;
	}


	/**
	 * Set the value of `details` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setDetails($v)
	{
		if ($this->details !== $v) {
			$this->details = $v;
			$this->modifiedColumns[] = TrackerItemPeer::DETAILS;
		}
				
	}


	/**
	 * Get the [optionally formatted] `last_modified_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getLastModifiedDate($format = 'Y-m-d H:i:s')
	{
		if ($this->last_modified_date === null || $this->last_modified_date === '') {
			return null;
		} elseif (!is_int($this->last_modified_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->last_modified_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of last_modified_date as date/time value: " . var_export($this->last_modified_date, true));
			}
		} else {
			$ts = $this->last_modified_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `last_modified_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setLastModifiedDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for last_modified_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->last_modified_date !== $ts || $ts === -1) {
			$this->last_modified_date = $ts;
			$this->modifiedColumns[] = TrackerItemPeer::LAST_MODIFIED_DATE;
		}
		
	}

  
	/**
	 * Get the LastModifiedBy column value.
	 *  
	 * @return int	  
	 */
	public function getLastModifiedBy()
	{
		return $this->last_modified_by;
	}


	/**
	 * Set the value of `last_modified_by` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setLastModifiedBy($v)
	{
		if ($this->last_modified_by !== $v || $v === 0) {
			$this->last_modified_by = $v;
			$this->modifiedColumns[] = TrackerItemPeer::LAST_MODIFIED_BY;
		}
				
	}

  
	/**
	 * Get the SortOrder column value.
	 *  
	 * @return int	  
	 */
	public function getSortOrder()
	{
		return $this->sort_order;
	}


	/**
	 * Set the value of `sort_order` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setSortOrder($v)
	{
		if ($this->sort_order !== $v || $v === 0) {
			$this->sort_order = $v;
			$this->modifiedColumns[] = TrackerItemPeer::SORT_ORDER;
		}
				
	}

  
	/**
	 * Get the ParentId column value.
	 *  
	 * @return int	  
	 */
	public function getParentId()
	{
		return $this->parent_id;
	}


	/**
	 * Set the value of `parent_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setParentId($v)
	{
		if ($this->parent_id !== $v || $v === 0) {
			$this->parent_id = $v;
			$this->modifiedColumns[] = TrackerItemPeer::PARENT_ID;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->tracker_item_id = $rs->getInt($startcol + 0);					
			$this->tracker_id = $rs->getInt($startcol + 1);					
			$this->status_id = $rs->getInt($startcol + 2);					
			$this->priority = $rs->getInt($startcol + 3);					
			$this->submitted_by = $rs->getInt($startcol + 4);					
			$this->open_date = $rs->getTimestamp($startcol + 5, null);
			$this->close_date = $rs->getTimestamp($startcol + 6, null);
			$this->summary = $rs->getString($startcol + 7);					
			$this->details = $rs->getString($startcol + 8);					
			$this->last_modified_date = $rs->getTimestamp($startcol + 9, null);
			$this->last_modified_by = $rs->getInt($startcol + 10);					
			$this->sort_order = $rs->getInt($startcol + 11);					
			$this->parent_id = $rs->getInt($startcol + 12);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating TrackerItem object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(TrackerItemPeer::DATABASE_NAME);
		$criteria->add(TrackerItemPeer::TRACKER_ITEM_ID, $this->tracker_item_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(TrackerItemPeer::DATABASE_NAME);
		if ($this->isColumnModified(TrackerItemPeer::TRACKER_ITEM_ID)) $criteria->add(TrackerItemPeer::TRACKER_ITEM_ID, $this->tracker_item_id);
		if ($this->isColumnModified(TrackerItemPeer::TRACKER_ID)) $criteria->add(TrackerItemPeer::TRACKER_ID, $this->tracker_id);
		if ($this->isColumnModified(TrackerItemPeer::STATUS_ID)) $criteria->add(TrackerItemPeer::STATUS_ID, $this->status_id);
		if ($this->isColumnModified(TrackerItemPeer::PRIORITY)) $criteria->add(TrackerItemPeer::PRIORITY, $this->priority);
		if ($this->isColumnModified(TrackerItemPeer::SUBMITTED_BY)) $criteria->add(TrackerItemPeer::SUBMITTED_BY, $this->submitted_by);
		if ($this->isColumnModified(TrackerItemPeer::OPEN_DATE)) $criteria->add(TrackerItemPeer::OPEN_DATE, $this->open_date);
		if ($this->isColumnModified(TrackerItemPeer::CLOSE_DATE)) $criteria->add(TrackerItemPeer::CLOSE_DATE, $this->close_date);
		if ($this->isColumnModified(TrackerItemPeer::SUMMARY)) $criteria->add(TrackerItemPeer::SUMMARY, $this->summary);
		if ($this->isColumnModified(TrackerItemPeer::DETAILS)) $criteria->add(TrackerItemPeer::DETAILS, $this->details);
		if ($this->isColumnModified(TrackerItemPeer::LAST_MODIFIED_DATE)) $criteria->add(TrackerItemPeer::LAST_MODIFIED_DATE, $this->last_modified_date);
		if ($this->isColumnModified(TrackerItemPeer::LAST_MODIFIED_BY)) $criteria->add(TrackerItemPeer::LAST_MODIFIED_BY, $this->last_modified_by);
		if ($this->isColumnModified(TrackerItemPeer::SORT_ORDER)) $criteria->add(TrackerItemPeer::SORT_ORDER, $this->sort_order);
		if ($this->isColumnModified(TrackerItemPeer::PARENT_ID)) $criteria->add(TrackerItemPeer::PARENT_ID, $this->parent_id);
		return $criteria;			
	}
	
	

	/**
	 * @var User	  
	 */
	protected $aUser;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{
			
		if ($v === null) {
			$this->setSubmittedBy(NULL);
		} else {
			$this->setSubmittedBy($v->getUserId());
		}
   
		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUser === null && ($this->submitted_by !== null)) {
	
			$this->aUser = UserPeer::retrieveByPK($this->submitted_by, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->submitted_by, $con);
			   $obj->addTrackerItems($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserKey($key)
	{

		$this->setSubmittedBy( (int) $key);			
		
	}

	/**
	 * @var Tracker	  
	 */
	protected $aTracker;

	/**
	 * Declares an association between this object and a Tracker object
	 *
	 * @param Tracker $v
	 * @return void
	 * @throws PropelException
	 */
	public function setTracker($v)
	{
			
		if ($v === null) {
			$this->setTrackerId(NULL);
		} else {
			$this->setTrackerId($v->getTrackerId());
		}
   
		$this->aTracker = $v;
	}


	/**
	 * Get the associated Tracker object
	 *
	 * @param Connection Optional Connection object.
	 * @return Tracker The associated Tracker object.
	 * @throws PropelException
	 */
	public function getTracker($con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerPeer.php';

		if ($this->aTracker === null && ($this->tracker_id !== null)) {
	
			$this->aTracker = TrackerPeer::retrieveByPK($this->tracker_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = TrackerPeer::retrieveByPK($this->tracker_id, $con);
			   $obj->addTrackerItems($this);
			 */
		}
		return $this->aTracker;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerKey($key)
	{

		$this->setTrackerId( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collCruisecontrolDefects	  
	 * @var array
	 */
	protected $collCruisecontrolDefects; 

	/**
	 * Temporary storage of collCruisecontrolDefects to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initCruisecontrolDefects()
	{
		if ($this->collCruisecontrolDefects === null) {
			$this->collCruisecontrolDefects = array();
		}
	}

	/**
	 * Method called to associate a CruisecontrolDefect object to this object
	 * through the CruisecontrolDefect foreign key attribute
	 *
	 * @param CruisecontrolDefect $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addCruisecontrolDefect(CruisecontrolDefect $l)
	{
		$this->collCruisecontrolDefects[] = $l;
		$l->setTrackerItem($this);
	}

	/**
	 * The criteria used to select the current contents of collCruisecontrolDefects.
	 * @var Criteria
	 */
	private $lastCruisecontrolDefectsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem has previously
	 * been saved, it will retrieve related CruisecontrolDefects from storage.
	 * If this TrackerItem is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getCruisecontrolDefects($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/cruisecontrol/lib/CruisecontrolDefectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collCruisecontrolDefects === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolDefects = array();
			} else {
	
				$criteria->add(CruisecontrolDefectPeer::TRACKER_ITEM_ID, $this->getTrackerItemId() );

				$this->collCruisecontrolDefects = CruisecontrolDefectPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(CruisecontrolDefectPeer::TRACKER_ITEM_ID, $this->getTrackerItemId());

				if (!isset($this->lastCruisecontrolDefectsCriteria) || !$this->lastCruisecontrolDefectsCriteria->equals($criteria)) {
					$this->collCruisecontrolDefects = CruisecontrolDefectPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCruisecontrolDefectsCriteria = $criteria;

		return $this->collCruisecontrolDefects;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem is new, it will return
	 * an empty collection; or if this TrackerItem has previously
	 * been saved, it will retrieve related CruisecontrolDefects from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerItem.
	 */
	public function getCruisecontrolDefectsJoinCruisecontrol($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/cruisecontrol/lib/CruisecontrolDefectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCruisecontrolDefects === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolDefects = array();
			} else {
	   
				$criteria->add(CruisecontrolDefectPeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
				$this->collCruisecontrolDefects = CruisecontrolDefectPeer::doSelectJoinCruisecontrol($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CruisecontrolDefectPeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
			if (!isset($this->lastCruisecontrolDefectsCriteria) || !$this->lastCruisecontrolDefectsCriteria->equals($criteria)) {
				$this->collCruisecontrolDefects = CruisecontrolDefectPeer::doSelectJoinCruisecontrol($criteria, $con);
			}
		}
		$this->lastCruisecontrolDefectsCriteria = $criteria;

		return $this->collCruisecontrolDefects;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem is new, it will return
	 * an empty collection; or if this TrackerItem has previously
	 * been saved, it will retrieve related CruisecontrolDefects from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerItem.
	 */
	public function getCruisecontrolDefectsJoinTrackerItem($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/cruisecontrol/lib/CruisecontrolDefectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCruisecontrolDefects === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolDefects = array();
			} else {
	   
				$criteria->add(CruisecontrolDefectPeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
				$this->collCruisecontrolDefects = CruisecontrolDefectPeer::doSelectJoinTrackerItem($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CruisecontrolDefectPeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
			if (!isset($this->lastCruisecontrolDefectsCriteria) || !$this->lastCruisecontrolDefectsCriteria->equals($criteria)) {
				$this->collCruisecontrolDefects = CruisecontrolDefectPeer::doSelectJoinTrackerItem($criteria, $con);
			}
		}
		$this->lastCruisecontrolDefectsCriteria = $criteria;

		return $this->collCruisecontrolDefects;
	}

	/**
	 * Collection to store aggregation of collTrackerItemScmCommits	  
	 * @var array
	 */
	protected $collTrackerItemScmCommits; 

	/**
	 * Temporary storage of collTrackerItemScmCommits to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerItemScmCommits()
	{
		if ($this->collTrackerItemScmCommits === null) {
			$this->collTrackerItemScmCommits = array();
		}
	}

	/**
	 * Method called to associate a TrackerItemScmCommit object to this object
	 * through the TrackerItemScmCommit foreign key attribute
	 *
	 * @param TrackerItemScmCommit $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerItemScmCommit(TrackerItemScmCommit $l)
	{
		$this->collTrackerItemScmCommits[] = $l;
		$l->setTrackerItem($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerItemScmCommits.
	 * @var Criteria
	 */
	private $lastTrackerItemScmCommitsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerItemScmCommits from storage.
	 * If this TrackerItem is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerItemScmCommits($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemScmCommitPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerItemScmCommits === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemScmCommits = array();
			} else {
	
				$criteria->add(TrackerItemScmCommitPeer::TRACKER_ITEM_ID, $this->getTrackerItemId() );

				$this->collTrackerItemScmCommits = TrackerItemScmCommitPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerItemScmCommitPeer::TRACKER_ITEM_ID, $this->getTrackerItemId());

				if (!isset($this->lastTrackerItemScmCommitsCriteria) || !$this->lastTrackerItemScmCommitsCriteria->equals($criteria)) {
					$this->collTrackerItemScmCommits = TrackerItemScmCommitPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerItemScmCommitsCriteria = $criteria;

		return $this->collTrackerItemScmCommits;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem is new, it will return
	 * an empty collection; or if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerItemScmCommits from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerItem.
	 */
	public function getTrackerItemScmCommitsJoinScmCommit($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemScmCommitPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItemScmCommits === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemScmCommits = array();
			} else {
	   
				$criteria->add(TrackerItemScmCommitPeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
				$this->collTrackerItemScmCommits = TrackerItemScmCommitPeer::doSelectJoinScmCommit($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemScmCommitPeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
			if (!isset($this->lastTrackerItemScmCommitsCriteria) || !$this->lastTrackerItemScmCommitsCriteria->equals($criteria)) {
				$this->collTrackerItemScmCommits = TrackerItemScmCommitPeer::doSelectJoinScmCommit($criteria, $con);
			}
		}
		$this->lastTrackerItemScmCommitsCriteria = $criteria;

		return $this->collTrackerItemScmCommits;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem is new, it will return
	 * an empty collection; or if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerItemScmCommits from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerItem.
	 */
	public function getTrackerItemScmCommitsJoinTrackerItem($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemScmCommitPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItemScmCommits === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemScmCommits = array();
			} else {
	   
				$criteria->add(TrackerItemScmCommitPeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
				$this->collTrackerItemScmCommits = TrackerItemScmCommitPeer::doSelectJoinTrackerItem($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemScmCommitPeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
			if (!isset($this->lastTrackerItemScmCommitsCriteria) || !$this->lastTrackerItemScmCommitsCriteria->equals($criteria)) {
				$this->collTrackerItemScmCommits = TrackerItemScmCommitPeer::doSelectJoinTrackerItem($criteria, $con);
			}
		}
		$this->lastTrackerItemScmCommitsCriteria = $criteria;

		return $this->collTrackerItemScmCommits;
	}

	/**
	 * Collection to store aggregation of collTrackerExtraFieldDatas	  
	 * @var array
	 */
	protected $collTrackerExtraFieldDatas; 

	/**
	 * Temporary storage of collTrackerExtraFieldDatas to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerExtraFieldDatas()
	{
		if ($this->collTrackerExtraFieldDatas === null) {
			$this->collTrackerExtraFieldDatas = array();
		}
	}

	/**
	 * Method called to associate a TrackerExtraFieldData object to this object
	 * through the TrackerExtraFieldData foreign key attribute
	 *
	 * @param TrackerExtraFieldData $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerExtraFieldData(TrackerExtraFieldData $l)
	{
		$this->collTrackerExtraFieldDatas[] = $l;
		$l->setTrackerItem($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerExtraFieldDatas.
	 * @var Criteria
	 */
	private $lastTrackerExtraFieldDatasCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerExtraFieldDatas from storage.
	 * If this TrackerItem is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerExtraFieldDatas($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerExtraFieldDataPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerExtraFieldDatas === null) {
			if ($this->isNew()) {
			   $this->collTrackerExtraFieldDatas = array();
			} else {
	
				$criteria->add(TrackerExtraFieldDataPeer::TRACKER_ITEM_ID, $this->getTrackerItemId() );

				$this->collTrackerExtraFieldDatas = TrackerExtraFieldDataPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerExtraFieldDataPeer::TRACKER_ITEM_ID, $this->getTrackerItemId());

				if (!isset($this->lastTrackerExtraFieldDatasCriteria) || !$this->lastTrackerExtraFieldDatasCriteria->equals($criteria)) {
					$this->collTrackerExtraFieldDatas = TrackerExtraFieldDataPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerExtraFieldDatasCriteria = $criteria;

		return $this->collTrackerExtraFieldDatas;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem is new, it will return
	 * an empty collection; or if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerExtraFieldDatas from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerItem.
	 */
	public function getTrackerExtraFieldDatasJoinTrackerExtraField($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerExtraFieldDataPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerExtraFieldDatas === null) {
			if ($this->isNew()) {
			   $this->collTrackerExtraFieldDatas = array();
			} else {
	   
				$criteria->add(TrackerExtraFieldDataPeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
				$this->collTrackerExtraFieldDatas = TrackerExtraFieldDataPeer::doSelectJoinTrackerExtraField($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerExtraFieldDataPeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
			if (!isset($this->lastTrackerExtraFieldDatasCriteria) || !$this->lastTrackerExtraFieldDatasCriteria->equals($criteria)) {
				$this->collTrackerExtraFieldDatas = TrackerExtraFieldDataPeer::doSelectJoinTrackerExtraField($criteria, $con);
			}
		}
		$this->lastTrackerExtraFieldDatasCriteria = $criteria;

		return $this->collTrackerExtraFieldDatas;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem is new, it will return
	 * an empty collection; or if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerExtraFieldDatas from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerItem.
	 */
	public function getTrackerExtraFieldDatasJoinTrackerItem($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerExtraFieldDataPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerExtraFieldDatas === null) {
			if ($this->isNew()) {
			   $this->collTrackerExtraFieldDatas = array();
			} else {
	   
				$criteria->add(TrackerExtraFieldDataPeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
				$this->collTrackerExtraFieldDatas = TrackerExtraFieldDataPeer::doSelectJoinTrackerItem($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerExtraFieldDataPeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
			if (!isset($this->lastTrackerExtraFieldDatasCriteria) || !$this->lastTrackerExtraFieldDatasCriteria->equals($criteria)) {
				$this->collTrackerExtraFieldDatas = TrackerExtraFieldDataPeer::doSelectJoinTrackerItem($criteria, $con);
			}
		}
		$this->lastTrackerExtraFieldDatasCriteria = $criteria;

		return $this->collTrackerExtraFieldDatas;
	}

	/**
	 * Collection to store aggregation of collTrackerMyQueues	  
	 * @var array
	 */
	protected $collTrackerMyQueues; 

	/**
	 * Temporary storage of collTrackerMyQueues to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerMyQueues()
	{
		if ($this->collTrackerMyQueues === null) {
			$this->collTrackerMyQueues = array();
		}
	}

	/**
	 * Method called to associate a TrackerMyQueue object to this object
	 * through the TrackerMyQueue foreign key attribute
	 *
	 * @param TrackerMyQueue $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerMyQueue(TrackerMyQueue $l)
	{
		$this->collTrackerMyQueues[] = $l;
		$l->setTrackerItem($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerMyQueues.
	 * @var Criteria
	 */
	private $lastTrackerMyQueuesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerMyQueues from storage.
	 * If this TrackerItem is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerMyQueues($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerMyQueuePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerMyQueues === null) {
			if ($this->isNew()) {
			   $this->collTrackerMyQueues = array();
			} else {
	
				$criteria->add(TrackerMyQueuePeer::TRACKER_ITEM_ID, $this->getTrackerItemId() );

				$this->collTrackerMyQueues = TrackerMyQueuePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerMyQueuePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());

				if (!isset($this->lastTrackerMyQueuesCriteria) || !$this->lastTrackerMyQueuesCriteria->equals($criteria)) {
					$this->collTrackerMyQueues = TrackerMyQueuePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerMyQueuesCriteria = $criteria;

		return $this->collTrackerMyQueues;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem is new, it will return
	 * an empty collection; or if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerMyQueues from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerItem.
	 */
	public function getTrackerMyQueuesJoinTrackerItem($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerMyQueuePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerMyQueues === null) {
			if ($this->isNew()) {
			   $this->collTrackerMyQueues = array();
			} else {
	   
				$criteria->add(TrackerMyQueuePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
				$this->collTrackerMyQueues = TrackerMyQueuePeer::doSelectJoinTrackerItem($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerMyQueuePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
			if (!isset($this->lastTrackerMyQueuesCriteria) || !$this->lastTrackerMyQueuesCriteria->equals($criteria)) {
				$this->collTrackerMyQueues = TrackerMyQueuePeer::doSelectJoinTrackerItem($criteria, $con);
			}
		}
		$this->lastTrackerMyQueuesCriteria = $criteria;

		return $this->collTrackerMyQueues;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem is new, it will return
	 * an empty collection; or if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerMyQueues from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerItem.
	 */
	public function getTrackerMyQueuesJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerMyQueuePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerMyQueues === null) {
			if ($this->isNew()) {
			   $this->collTrackerMyQueues = array();
			} else {
	   
				$criteria->add(TrackerMyQueuePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
				$this->collTrackerMyQueues = TrackerMyQueuePeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerMyQueuePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
			if (!isset($this->lastTrackerMyQueuesCriteria) || !$this->lastTrackerMyQueuesCriteria->equals($criteria)) {
				$this->collTrackerMyQueues = TrackerMyQueuePeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastTrackerMyQueuesCriteria = $criteria;

		return $this->collTrackerMyQueues;
	}

	/**
	 * Collection to store aggregation of collTrackerItemAssignees	  
	 * @var array
	 */
	protected $collTrackerItemAssignees; 

	/**
	 * Temporary storage of collTrackerItemAssignees to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerItemAssignees()
	{
		if ($this->collTrackerItemAssignees === null) {
			$this->collTrackerItemAssignees = array();
		}
	}

	/**
	 * Method called to associate a TrackerItemAssignee object to this object
	 * through the TrackerItemAssignee foreign key attribute
	 *
	 * @param TrackerItemAssignee $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerItemAssignee(TrackerItemAssignee $l)
	{
		$this->collTrackerItemAssignees[] = $l;
		$l->setTrackerItem($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerItemAssignees.
	 * @var Criteria
	 */
	private $lastTrackerItemAssigneesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerItemAssignees from storage.
	 * If this TrackerItem is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerItemAssignees($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemAssigneePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerItemAssignees === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemAssignees = array();
			} else {
	
				$criteria->add(TrackerItemAssigneePeer::TRACKER_ITEM_ID, $this->getTrackerItemId() );

				$this->collTrackerItemAssignees = TrackerItemAssigneePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerItemAssigneePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());

				if (!isset($this->lastTrackerItemAssigneesCriteria) || !$this->lastTrackerItemAssigneesCriteria->equals($criteria)) {
					$this->collTrackerItemAssignees = TrackerItemAssigneePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerItemAssigneesCriteria = $criteria;

		return $this->collTrackerItemAssignees;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem is new, it will return
	 * an empty collection; or if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerItemAssignees from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerItem.
	 */
	public function getTrackerItemAssigneesJoinTrackerItem($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemAssigneePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItemAssignees === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemAssignees = array();
			} else {
	   
				$criteria->add(TrackerItemAssigneePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
				$this->collTrackerItemAssignees = TrackerItemAssigneePeer::doSelectJoinTrackerItem($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemAssigneePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
			if (!isset($this->lastTrackerItemAssigneesCriteria) || !$this->lastTrackerItemAssigneesCriteria->equals($criteria)) {
				$this->collTrackerItemAssignees = TrackerItemAssigneePeer::doSelectJoinTrackerItem($criteria, $con);
			}
		}
		$this->lastTrackerItemAssigneesCriteria = $criteria;

		return $this->collTrackerItemAssignees;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem is new, it will return
	 * an empty collection; or if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerItemAssignees from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerItem.
	 */
	public function getTrackerItemAssigneesJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemAssigneePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItemAssignees === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemAssignees = array();
			} else {
	   
				$criteria->add(TrackerItemAssigneePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
				$this->collTrackerItemAssignees = TrackerItemAssigneePeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemAssigneePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
			if (!isset($this->lastTrackerItemAssigneesCriteria) || !$this->lastTrackerItemAssigneesCriteria->equals($criteria)) {
				$this->collTrackerItemAssignees = TrackerItemAssigneePeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastTrackerItemAssigneesCriteria = $criteria;

		return $this->collTrackerItemAssignees;
	}

	/**
	 * Collection to store aggregation of collTrackerItemMessages	  
	 * @var array
	 */
	protected $collTrackerItemMessages; 

	/**
	 * Temporary storage of collTrackerItemMessages to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerItemMessages()
	{
		if ($this->collTrackerItemMessages === null) {
			$this->collTrackerItemMessages = array();
		}
	}

	/**
	 * Method called to associate a TrackerItemMessage object to this object
	 * through the TrackerItemMessage foreign key attribute
	 *
	 * @param TrackerItemMessage $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerItemMessage(TrackerItemMessage $l)
	{
		$this->collTrackerItemMessages[] = $l;
		$l->setTrackerItem($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerItemMessages.
	 * @var Criteria
	 */
	private $lastTrackerItemMessagesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerItemMessages from storage.
	 * If this TrackerItem is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerItemMessages($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemMessagePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerItemMessages === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemMessages = array();
			} else {
	
				$criteria->add(TrackerItemMessagePeer::TRACKER_ITEM_ID, $this->getTrackerItemId() );

				$this->collTrackerItemMessages = TrackerItemMessagePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerItemMessagePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());

				if (!isset($this->lastTrackerItemMessagesCriteria) || !$this->lastTrackerItemMessagesCriteria->equals($criteria)) {
					$this->collTrackerItemMessages = TrackerItemMessagePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerItemMessagesCriteria = $criteria;

		return $this->collTrackerItemMessages;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem is new, it will return
	 * an empty collection; or if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerItemMessages from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerItem.
	 */
	public function getTrackerItemMessagesJoinTrackerItem($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemMessagePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItemMessages === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemMessages = array();
			} else {
	   
				$criteria->add(TrackerItemMessagePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
				$this->collTrackerItemMessages = TrackerItemMessagePeer::doSelectJoinTrackerItem($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemMessagePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
			if (!isset($this->lastTrackerItemMessagesCriteria) || !$this->lastTrackerItemMessagesCriteria->equals($criteria)) {
				$this->collTrackerItemMessages = TrackerItemMessagePeer::doSelectJoinTrackerItem($criteria, $con);
			}
		}
		$this->lastTrackerItemMessagesCriteria = $criteria;

		return $this->collTrackerItemMessages;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem is new, it will return
	 * an empty collection; or if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerItemMessages from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerItem.
	 */
	public function getTrackerItemMessagesJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemMessagePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItemMessages === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemMessages = array();
			} else {
	   
				$criteria->add(TrackerItemMessagePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
				$this->collTrackerItemMessages = TrackerItemMessagePeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemMessagePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
			if (!isset($this->lastTrackerItemMessagesCriteria) || !$this->lastTrackerItemMessagesCriteria->equals($criteria)) {
				$this->collTrackerItemMessages = TrackerItemMessagePeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastTrackerItemMessagesCriteria = $criteria;

		return $this->collTrackerItemMessages;
	}

	/**
	 * Collection to store aggregation of collTrackerItemRelationsRelatedByRelatedTrackerItemId	  
	 * @var array
	 */
	protected $collTrackerItemRelationsRelatedByRelatedTrackerItemId; 

	/**
	 * Temporary storage of collTrackerItemRelationsRelatedByRelatedTrackerItemId to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerItemRelationsRelatedByRelatedTrackerItemId()
	{
		if ($this->collTrackerItemRelationsRelatedByRelatedTrackerItemId === null) {
			$this->collTrackerItemRelationsRelatedByRelatedTrackerItemId = array();
		}
	}

	/**
	 * Method called to associate a TrackerItemRelation object to this object
	 * through the TrackerItemRelation foreign key attribute
	 *
	 * @param TrackerItemRelation $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerItemRelationRelatedByRelatedTrackerItemId(TrackerItemRelation $l)
	{
		$this->collTrackerItemRelationsRelatedByRelatedTrackerItemId[] = $l;
		$l->setTrackerItemRelatedByRelatedTrackerItemId($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerItemRelationsRelatedByRelatedTrackerItemId.
	 * @var Criteria
	 */
	private $lastTrackerItemRelationsRelatedByRelatedTrackerItemIdCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerItemRelationsRelatedByRelatedTrackerItemId from storage.
	 * If this TrackerItem is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerItemRelationsRelatedByRelatedTrackerItemId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemRelationPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerItemRelationsRelatedByRelatedTrackerItemId === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemRelationsRelatedByRelatedTrackerItemId = array();
			} else {
	
				$criteria->add(TrackerItemRelationPeer::RELATED_TRACKER_ITEM_ID, $this->getTrackerItemId() );

				$this->collTrackerItemRelationsRelatedByRelatedTrackerItemId = TrackerItemRelationPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerItemRelationPeer::RELATED_TRACKER_ITEM_ID, $this->getTrackerItemId());

				if (!isset($this->lastTrackerItemRelationsRelatedByRelatedTrackerItemIdCriteria) || !$this->lastTrackerItemRelationsRelatedByRelatedTrackerItemIdCriteria->equals($criteria)) {
					$this->collTrackerItemRelationsRelatedByRelatedTrackerItemId = TrackerItemRelationPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerItemRelationsRelatedByRelatedTrackerItemIdCriteria = $criteria;

		return $this->collTrackerItemRelationsRelatedByRelatedTrackerItemId;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem is new, it will return
	 * an empty collection; or if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerItemRelationsRelatedByRelatedTrackerItemId from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerItem.
	 */
	public function getTrackerItemRelationsRelatedByRelatedTrackerItemIdJoinTrackerItemRelatedByTrackerItemId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemRelationPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItemRelationsRelatedByRelatedTrackerItemId === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemRelationsRelatedByRelatedTrackerItemId = array();
			} else {
	   
				$criteria->add(TrackerItemRelationPeer::RELATED_TRACKER_ITEM_ID, $this->getTrackerItemId());
				$this->collTrackerItemRelationsRelatedByRelatedTrackerItemId = TrackerItemRelationPeer::doSelectJoinTrackerItemRelatedByTrackerItemId($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemRelationPeer::RELATED_TRACKER_ITEM_ID, $this->getTrackerItemId());
			if (!isset($this->lastTrackerItemRelationsRelatedByRelatedTrackerItemIdCriteria) || !$this->lastTrackerItemRelationsRelatedByRelatedTrackerItemIdCriteria->equals($criteria)) {
				$this->collTrackerItemRelationsRelatedByRelatedTrackerItemId = TrackerItemRelationPeer::doSelectJoinTrackerItemRelatedByTrackerItemId($criteria, $con);
			}
		}
		$this->lastTrackerItemRelationsRelatedByRelatedTrackerItemIdCriteria = $criteria;

		return $this->collTrackerItemRelationsRelatedByRelatedTrackerItemId;
	}

	/**
	 * Collection to store aggregation of collTrackerItemRelationsRelatedByTrackerItemId	  
	 * @var array
	 */
	protected $collTrackerItemRelationsRelatedByTrackerItemId; 

	/**
	 * Temporary storage of collTrackerItemRelationsRelatedByTrackerItemId to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerItemRelationsRelatedByTrackerItemId()
	{
		if ($this->collTrackerItemRelationsRelatedByTrackerItemId === null) {
			$this->collTrackerItemRelationsRelatedByTrackerItemId = array();
		}
	}

	/**
	 * Method called to associate a TrackerItemRelation object to this object
	 * through the TrackerItemRelation foreign key attribute
	 *
	 * @param TrackerItemRelation $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerItemRelationRelatedByTrackerItemId(TrackerItemRelation $l)
	{
		$this->collTrackerItemRelationsRelatedByTrackerItemId[] = $l;
		$l->setTrackerItemRelatedByTrackerItemId($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerItemRelationsRelatedByTrackerItemId.
	 * @var Criteria
	 */
	private $lastTrackerItemRelationsRelatedByTrackerItemIdCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerItemRelationsRelatedByTrackerItemId from storage.
	 * If this TrackerItem is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerItemRelationsRelatedByTrackerItemId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemRelationPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerItemRelationsRelatedByTrackerItemId === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemRelationsRelatedByTrackerItemId = array();
			} else {
	
				$criteria->add(TrackerItemRelationPeer::TRACKER_ITEM_ID, $this->getTrackerItemId() );

				$this->collTrackerItemRelationsRelatedByTrackerItemId = TrackerItemRelationPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerItemRelationPeer::TRACKER_ITEM_ID, $this->getTrackerItemId());

				if (!isset($this->lastTrackerItemRelationsRelatedByTrackerItemIdCriteria) || !$this->lastTrackerItemRelationsRelatedByTrackerItemIdCriteria->equals($criteria)) {
					$this->collTrackerItemRelationsRelatedByTrackerItemId = TrackerItemRelationPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerItemRelationsRelatedByTrackerItemIdCriteria = $criteria;

		return $this->collTrackerItemRelationsRelatedByTrackerItemId;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem is new, it will return
	 * an empty collection; or if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerItemRelationsRelatedByTrackerItemId from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerItem.
	 */
	public function getTrackerItemRelationsRelatedByTrackerItemIdJoinTrackerItemRelatedByRelatedTrackerItemId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemRelationPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItemRelationsRelatedByTrackerItemId === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemRelationsRelatedByTrackerItemId = array();
			} else {
	   
				$criteria->add(TrackerItemRelationPeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
				$this->collTrackerItemRelationsRelatedByTrackerItemId = TrackerItemRelationPeer::doSelectJoinTrackerItemRelatedByRelatedTrackerItemId($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemRelationPeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
			if (!isset($this->lastTrackerItemRelationsRelatedByTrackerItemIdCriteria) || !$this->lastTrackerItemRelationsRelatedByTrackerItemIdCriteria->equals($criteria)) {
				$this->collTrackerItemRelationsRelatedByTrackerItemId = TrackerItemRelationPeer::doSelectJoinTrackerItemRelatedByRelatedTrackerItemId($criteria, $con);
			}
		}
		$this->lastTrackerItemRelationsRelatedByTrackerItemIdCriteria = $criteria;

		return $this->collTrackerItemRelationsRelatedByTrackerItemId;
	}

	/**
	 * Collection to store aggregation of collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId	  
	 * @var array
	 */
	protected $collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId; 

	/**
	 * Temporary storage of collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId()
	{
		if ($this->collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId === null) {
			$this->collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId = array();
		}
	}

	/**
	 * Method called to associate a TrackerItemDuplicate object to this object
	 * through the TrackerItemDuplicate foreign key attribute
	 *
	 * @param TrackerItemDuplicate $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerItemDuplicateRelatedByDuplicateOfTrackerItemId(TrackerItemDuplicate $l)
	{
		$this->collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId[] = $l;
		$l->setTrackerItemRelatedByDuplicateOfTrackerItemId($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId.
	 * @var Criteria
	 */
	private $lastTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemIdCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId from storage.
	 * If this TrackerItem is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemDuplicatePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId = array();
			} else {
	
				$criteria->add(TrackerItemDuplicatePeer::DUPLICATE_OF_TRACKER_ITEM_ID, $this->getTrackerItemId() );

				$this->collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId = TrackerItemDuplicatePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerItemDuplicatePeer::DUPLICATE_OF_TRACKER_ITEM_ID, $this->getTrackerItemId());

				if (!isset($this->lastTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemIdCriteria) || !$this->lastTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemIdCriteria->equals($criteria)) {
					$this->collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId = TrackerItemDuplicatePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemIdCriteria = $criteria;

		return $this->collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem is new, it will return
	 * an empty collection; or if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerItem.
	 */
	public function getTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemIdJoinTrackerItemRelatedByTrackerItemId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemDuplicatePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId = array();
			} else {
	   
				$criteria->add(TrackerItemDuplicatePeer::DUPLICATE_OF_TRACKER_ITEM_ID, $this->getTrackerItemId());
				$this->collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId = TrackerItemDuplicatePeer::doSelectJoinTrackerItemRelatedByTrackerItemId($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemDuplicatePeer::DUPLICATE_OF_TRACKER_ITEM_ID, $this->getTrackerItemId());
			if (!isset($this->lastTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemIdCriteria) || !$this->lastTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemIdCriteria->equals($criteria)) {
				$this->collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId = TrackerItemDuplicatePeer::doSelectJoinTrackerItemRelatedByTrackerItemId($criteria, $con);
			}
		}
		$this->lastTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemIdCriteria = $criteria;

		return $this->collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId;
	}

	/**
	 * Collection to store aggregation of collTrackerItemDuplicatesRelatedByTrackerItemId	  
	 * @var array
	 */
	protected $collTrackerItemDuplicatesRelatedByTrackerItemId; 

	/**
	 * Temporary storage of collTrackerItemDuplicatesRelatedByTrackerItemId to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerItemDuplicatesRelatedByTrackerItemId()
	{
		if ($this->collTrackerItemDuplicatesRelatedByTrackerItemId === null) {
			$this->collTrackerItemDuplicatesRelatedByTrackerItemId = array();
		}
	}

	/**
	 * Method called to associate a TrackerItemDuplicate object to this object
	 * through the TrackerItemDuplicate foreign key attribute
	 *
	 * @param TrackerItemDuplicate $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerItemDuplicateRelatedByTrackerItemId(TrackerItemDuplicate $l)
	{
		$this->collTrackerItemDuplicatesRelatedByTrackerItemId[] = $l;
		$l->setTrackerItemRelatedByTrackerItemId($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerItemDuplicatesRelatedByTrackerItemId.
	 * @var Criteria
	 */
	private $lastTrackerItemDuplicatesRelatedByTrackerItemIdCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerItemDuplicatesRelatedByTrackerItemId from storage.
	 * If this TrackerItem is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerItemDuplicatesRelatedByTrackerItemId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemDuplicatePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerItemDuplicatesRelatedByTrackerItemId === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemDuplicatesRelatedByTrackerItemId = array();
			} else {
	
				$criteria->add(TrackerItemDuplicatePeer::TRACKER_ITEM_ID, $this->getTrackerItemId() );

				$this->collTrackerItemDuplicatesRelatedByTrackerItemId = TrackerItemDuplicatePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerItemDuplicatePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());

				if (!isset($this->lastTrackerItemDuplicatesRelatedByTrackerItemIdCriteria) || !$this->lastTrackerItemDuplicatesRelatedByTrackerItemIdCriteria->equals($criteria)) {
					$this->collTrackerItemDuplicatesRelatedByTrackerItemId = TrackerItemDuplicatePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerItemDuplicatesRelatedByTrackerItemIdCriteria = $criteria;

		return $this->collTrackerItemDuplicatesRelatedByTrackerItemId;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem is new, it will return
	 * an empty collection; or if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerItemDuplicatesRelatedByTrackerItemId from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerItem.
	 */
	public function getTrackerItemDuplicatesRelatedByTrackerItemIdJoinTrackerItemRelatedByDuplicateOfTrackerItemId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemDuplicatePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItemDuplicatesRelatedByTrackerItemId === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemDuplicatesRelatedByTrackerItemId = array();
			} else {
	   
				$criteria->add(TrackerItemDuplicatePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
				$this->collTrackerItemDuplicatesRelatedByTrackerItemId = TrackerItemDuplicatePeer::doSelectJoinTrackerItemRelatedByDuplicateOfTrackerItemId($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemDuplicatePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
			if (!isset($this->lastTrackerItemDuplicatesRelatedByTrackerItemIdCriteria) || !$this->lastTrackerItemDuplicatesRelatedByTrackerItemIdCriteria->equals($criteria)) {
				$this->collTrackerItemDuplicatesRelatedByTrackerItemId = TrackerItemDuplicatePeer::doSelectJoinTrackerItemRelatedByDuplicateOfTrackerItemId($criteria, $con);
			}
		}
		$this->lastTrackerItemDuplicatesRelatedByTrackerItemIdCriteria = $criteria;

		return $this->collTrackerItemDuplicatesRelatedByTrackerItemId;
	}

	/**
	 * Collection to store aggregation of collTrackerItemTimes	  
	 * @var array
	 */
	protected $collTrackerItemTimes; 

	/**
	 * Temporary storage of collTrackerItemTimes to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerItemTimes()
	{
		if ($this->collTrackerItemTimes === null) {
			$this->collTrackerItemTimes = array();
		}
	}

	/**
	 * Method called to associate a TrackerItemTime object to this object
	 * through the TrackerItemTime foreign key attribute
	 *
	 * @param TrackerItemTime $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerItemTime(TrackerItemTime $l)
	{
		$this->collTrackerItemTimes[] = $l;
		$l->setTrackerItem($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerItemTimes.
	 * @var Criteria
	 */
	private $lastTrackerItemTimesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerItemTimes from storage.
	 * If this TrackerItem is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerItemTimes($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemTimePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerItemTimes === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemTimes = array();
			} else {
	
				$criteria->add(TrackerItemTimePeer::TRACKER_ITEM_ID, $this->getTrackerItemId() );

				$this->collTrackerItemTimes = TrackerItemTimePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerItemTimePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());

				if (!isset($this->lastTrackerItemTimesCriteria) || !$this->lastTrackerItemTimesCriteria->equals($criteria)) {
					$this->collTrackerItemTimes = TrackerItemTimePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerItemTimesCriteria = $criteria;

		return $this->collTrackerItemTimes;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem is new, it will return
	 * an empty collection; or if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerItemTimes from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerItem.
	 */
	public function getTrackerItemTimesJoinTrackerItem($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemTimePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItemTimes === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemTimes = array();
			} else {
	   
				$criteria->add(TrackerItemTimePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
				$this->collTrackerItemTimes = TrackerItemTimePeer::doSelectJoinTrackerItem($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemTimePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
			if (!isset($this->lastTrackerItemTimesCriteria) || !$this->lastTrackerItemTimesCriteria->equals($criteria)) {
				$this->collTrackerItemTimes = TrackerItemTimePeer::doSelectJoinTrackerItem($criteria, $con);
			}
		}
		$this->lastTrackerItemTimesCriteria = $criteria;

		return $this->collTrackerItemTimes;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem is new, it will return
	 * an empty collection; or if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerItemTimes from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerItem.
	 */
	public function getTrackerItemTimesJoinTrackerTimeCode($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemTimePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItemTimes === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemTimes = array();
			} else {
	   
				$criteria->add(TrackerItemTimePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
				$this->collTrackerItemTimes = TrackerItemTimePeer::doSelectJoinTrackerTimeCode($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemTimePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
			if (!isset($this->lastTrackerItemTimesCriteria) || !$this->lastTrackerItemTimesCriteria->equals($criteria)) {
				$this->collTrackerItemTimes = TrackerItemTimePeer::doSelectJoinTrackerTimeCode($criteria, $con);
			}
		}
		$this->lastTrackerItemTimesCriteria = $criteria;

		return $this->collTrackerItemTimes;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerItem is new, it will return
	 * an empty collection; or if this TrackerItem has previously
	 * been saved, it will retrieve related TrackerItemTimes from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerItem.
	 */
	public function getTrackerItemTimesJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemTimePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerItemTimes === null) {
			if ($this->isNew()) {
			   $this->collTrackerItemTimes = array();
			} else {
	   
				$criteria->add(TrackerItemTimePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
				$this->collTrackerItemTimes = TrackerItemTimePeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerItemTimePeer::TRACKER_ITEM_ID, $this->getTrackerItemId());
			if (!isset($this->lastTrackerItemTimesCriteria) || !$this->lastTrackerItemTimesCriteria->equals($criteria)) {
				$this->collTrackerItemTimes = TrackerItemTimePeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastTrackerItemTimesCriteria = $criteria;

		return $this->collTrackerItemTimes;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("tracker_item_id", "tracker_id", "status_id", "priority", "submitted_by", "open_date", "close_date", "summary", "details", "last_modified_date", "last_modified_by", "sort_order", "parent_id", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case TrackerItemPeer::TRACKER_ITEM_ID:
				return $this->getTrackerItemId();
				break;
		  
			case TrackerItemPeer::TRACKER_ID:
				return $this->getTrackerId();
				break;
		  
			case TrackerItemPeer::STATUS_ID:
				return $this->getStatusId();
				break;
		  
			case TrackerItemPeer::PRIORITY:
				return $this->getPriority();
				break;
		  
			case TrackerItemPeer::SUBMITTED_BY:
				return $this->getSubmittedBy();
				break;
		  
			case TrackerItemPeer::OPEN_DATE:
				return $this->getOpenDate();
				break;
		  
			case TrackerItemPeer::CLOSE_DATE:
				return $this->getCloseDate();
				break;
		  
			case TrackerItemPeer::SUMMARY:
				return $this->getSummary();
				break;
		  
			case TrackerItemPeer::DETAILS:
				return $this->getDetails();
				break;
		  
			case TrackerItemPeer::LAST_MODIFIED_DATE:
				return $this->getLastModifiedDate();
				break;
		  
			case TrackerItemPeer::LAST_MODIFIED_BY:
				return $this->getLastModifiedBy();
				break;
		  
			case TrackerItemPeer::SORT_ORDER:
				return $this->getSortOrder();
				break;
		  
			case TrackerItemPeer::PARENT_ID:
				return $this->getParentId();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getTrackerItemId();
				break;
  
			case 1:
				return $this->getTrackerId();
				break;
  
			case 2:
				return $this->getStatusId();
				break;
  
			case 3:
				return $this->getPriority();
				break;
  
			case 4:
				return $this->getSubmittedBy();
				break;
  
			case 5:
				return $this->getOpenDate();
				break;
  
			case 6:
				return $this->getCloseDate();
				break;
  
			case 7:
				return $this->getSummary();
				break;
  
			case 8:
				return $this->getDetails();
				break;
  
			case 9:
				return $this->getLastModifiedDate();
				break;
  
			case 10:
				return $this->getLastModifiedBy();
				break;
  
			case 11:
				return $this->getSortOrder();
				break;
  
			case 12:
				return $this->getParentId();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(TrackerItemPeer::TRACKER_ITEM_ID, $arr)) $this->setTrackerItemId($arr[TrackerItemPeer::TRACKER_ITEM_ID]);
  
		if (array_key_exists(TrackerItemPeer::TRACKER_ID, $arr)) $this->setTrackerId($arr[TrackerItemPeer::TRACKER_ID]);
  
		if (array_key_exists(TrackerItemPeer::STATUS_ID, $arr)) $this->setStatusId($arr[TrackerItemPeer::STATUS_ID]);
  
		if (array_key_exists(TrackerItemPeer::PRIORITY, $arr)) $this->setPriority($arr[TrackerItemPeer::PRIORITY]);
  
		if (array_key_exists(TrackerItemPeer::SUBMITTED_BY, $arr)) $this->setSubmittedBy($arr[TrackerItemPeer::SUBMITTED_BY]);
  
		if (array_key_exists(TrackerItemPeer::OPEN_DATE, $arr)) $this->setOpenDate($arr[TrackerItemPeer::OPEN_DATE]);
  
		if (array_key_exists(TrackerItemPeer::CLOSE_DATE, $arr)) $this->setCloseDate($arr[TrackerItemPeer::CLOSE_DATE]);
  
		if (array_key_exists(TrackerItemPeer::SUMMARY, $arr)) $this->setSummary($arr[TrackerItemPeer::SUMMARY]);
  
		if (array_key_exists(TrackerItemPeer::DETAILS, $arr)) $this->setDetails($arr[TrackerItemPeer::DETAILS]);
  
		if (array_key_exists(TrackerItemPeer::LAST_MODIFIED_DATE, $arr)) $this->setLastModifiedDate($arr[TrackerItemPeer::LAST_MODIFIED_DATE]);
  
		if (array_key_exists(TrackerItemPeer::LAST_MODIFIED_BY, $arr)) $this->setLastModifiedBy($arr[TrackerItemPeer::LAST_MODIFIED_BY]);
  
		if (array_key_exists(TrackerItemPeer::SORT_ORDER, $arr)) $this->setSortOrder($arr[TrackerItemPeer::SORT_ORDER]);
  
		if (array_key_exists(TrackerItemPeer::PARENT_ID, $arr)) $this->setParentId($arr[TrackerItemPeer::PARENT_ID]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case TrackerItemPeer::TRACKER_ITEM_ID:
				$this->setTrackerItemId($value);
				break;
	  
			case TrackerItemPeer::TRACKER_ID:
				$this->setTrackerId($value);
				break;
	  
			case TrackerItemPeer::STATUS_ID:
				$this->setStatusId($value);
				break;
	  
			case TrackerItemPeer::PRIORITY:
				$this->setPriority($value);
				break;
	  
			case TrackerItemPeer::SUBMITTED_BY:
				$this->setSubmittedBy($value);
				break;
	  
			case TrackerItemPeer::OPEN_DATE:
				$this->setOpenDate($value);
				break;
	  
			case TrackerItemPeer::CLOSE_DATE:
				$this->setCloseDate($value);
				break;
	  
			case TrackerItemPeer::SUMMARY:
				$this->setSummary($value);
				break;
	  
			case TrackerItemPeer::DETAILS:
				$this->setDetails($value);
				break;
	  
			case TrackerItemPeer::LAST_MODIFIED_DATE:
				$this->setLastModifiedDate($value);
				break;
	  
			case TrackerItemPeer::LAST_MODIFIED_BY:
				$this->setLastModifiedBy($value);
				break;
	  
			case TrackerItemPeer::SORT_ORDER:
				$this->setSortOrder($value);
				break;
	  
			case TrackerItemPeer::PARENT_ID:
				$this->setParentId($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setTrackerItemId($value);
				break;
  
			case 1:
				$this->setTrackerId($value);
				break;
  
			case 2:
				$this->setStatusId($value);
				break;
  
			case 3:
				$this->setPriority($value);
				break;
  
			case 4:
				$this->setSubmittedBy($value);
				break;
  
			case 5:
				$this->setOpenDate($value);
				break;
  
			case 6:
				$this->setCloseDate($value);
				break;
  
			case 7:
				$this->setSummary($value);
				break;
  
			case 8:
				$this->setDetails($value);
				break;
  
			case 9:
				$this->setLastModifiedDate($value);
				break;
  
			case 10:
				$this->setLastModifiedBy($value);
				break;
  
			case 11:
				$this->setSortOrder($value);
				break;
  
			case 12:
				$this->setParentId($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerItemPeer::DATABASE_NAME);

		try {
			$con->begin();
			TrackerItemPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerItemPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) $this->aUser->save($con);
				$this->setUser($this->aUser);
			}
 
			if ($this->aTracker !== null) {
				if ($this->aTracker->isModified()) $this->aTracker->save($con);
				$this->setTracker($this->aTracker);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = TrackerItemPeer::doInsert($this, $con);
					$this->setTrackerItemId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					TrackerItemPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collCruisecontrolDefects !== null) {
				for ($i=0,$size=count($this->collCruisecontrolDefects); $i < $size; $i++) {
					$this->collCruisecontrolDefects[$i]->save($con);
				}
			  }
			if ($this->collTrackerItemScmCommits !== null) {
				for ($i=0,$size=count($this->collTrackerItemScmCommits); $i < $size; $i++) {
					$this->collTrackerItemScmCommits[$i]->save($con);
				}
			  }
			if ($this->collTrackerExtraFieldDatas !== null) {
				for ($i=0,$size=count($this->collTrackerExtraFieldDatas); $i < $size; $i++) {
					$this->collTrackerExtraFieldDatas[$i]->save($con);
				}
			  }
			if ($this->collTrackerMyQueues !== null) {
				for ($i=0,$size=count($this->collTrackerMyQueues); $i < $size; $i++) {
					$this->collTrackerMyQueues[$i]->save($con);
				}
			  }
			if ($this->collTrackerItemAssignees !== null) {
				for ($i=0,$size=count($this->collTrackerItemAssignees); $i < $size; $i++) {
					$this->collTrackerItemAssignees[$i]->save($con);
				}
			  }
			if ($this->collTrackerItemMessages !== null) {
				for ($i=0,$size=count($this->collTrackerItemMessages); $i < $size; $i++) {
					$this->collTrackerItemMessages[$i]->save($con);
				}
			  }
			if ($this->collTrackerItemRelationsRelatedByRelatedTrackerItemId !== null) {
				for ($i=0,$size=count($this->collTrackerItemRelationsRelatedByRelatedTrackerItemId); $i < $size; $i++) {
					$this->collTrackerItemRelationsRelatedByRelatedTrackerItemId[$i]->save($con);
				}
			  }
			if ($this->collTrackerItemRelationsRelatedByTrackerItemId !== null) {
				for ($i=0,$size=count($this->collTrackerItemRelationsRelatedByTrackerItemId); $i < $size; $i++) {
					$this->collTrackerItemRelationsRelatedByTrackerItemId[$i]->save($con);
				}
			  }
			if ($this->collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId !== null) {
				for ($i=0,$size=count($this->collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId); $i < $size; $i++) {
					$this->collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId[$i]->save($con);
				}
			  }
			if ($this->collTrackerItemDuplicatesRelatedByTrackerItemId !== null) {
				for ($i=0,$size=count($this->collTrackerItemDuplicatesRelatedByTrackerItemId); $i < $size; $i++) {
					$this->collTrackerItemDuplicatesRelatedByTrackerItemId[$i]->save($con);
				}
			  }
			if ($this->collTrackerItemTimes !== null) {
				for ($i=0,$size=count($this->collTrackerItemTimes); $i < $size; $i++) {
					$this->collTrackerItemTimes[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return TrackerItemPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aTracker !== null) {
				if (($retval = $this->aTracker->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = TrackerItemPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collCruisecontrolDefects !== null) {
				for ($i=0,$size=count($this->collCruisecontrolDefects); $i < $size; $i++) {
					if (($retval = $this->collCruisecontrolDefects[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerItemScmCommits !== null) {
				for ($i=0,$size=count($this->collTrackerItemScmCommits); $i < $size; $i++) {
					if (($retval = $this->collTrackerItemScmCommits[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerExtraFieldDatas !== null) {
				for ($i=0,$size=count($this->collTrackerExtraFieldDatas); $i < $size; $i++) {
					if (($retval = $this->collTrackerExtraFieldDatas[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerMyQueues !== null) {
				for ($i=0,$size=count($this->collTrackerMyQueues); $i < $size; $i++) {
					if (($retval = $this->collTrackerMyQueues[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerItemAssignees !== null) {
				for ($i=0,$size=count($this->collTrackerItemAssignees); $i < $size; $i++) {
					if (($retval = $this->collTrackerItemAssignees[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerItemMessages !== null) {
				for ($i=0,$size=count($this->collTrackerItemMessages); $i < $size; $i++) {
					if (($retval = $this->collTrackerItemMessages[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerItemRelationsRelatedByRelatedTrackerItemId !== null) {
				for ($i=0,$size=count($this->collTrackerItemRelationsRelatedByRelatedTrackerItemId); $i < $size; $i++) {
					if (($retval = $this->collTrackerItemRelationsRelatedByRelatedTrackerItemId[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerItemRelationsRelatedByTrackerItemId !== null) {
				for ($i=0,$size=count($this->collTrackerItemRelationsRelatedByTrackerItemId); $i < $size; $i++) {
					if (($retval = $this->collTrackerItemRelationsRelatedByTrackerItemId[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId !== null) {
				for ($i=0,$size=count($this->collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId); $i < $size; $i++) {
					if (($retval = $this->collTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerItemDuplicatesRelatedByTrackerItemId !== null) {
				for ($i=0,$size=count($this->collTrackerItemDuplicatesRelatedByTrackerItemId); $i < $size; $i++) {
					if (($retval = $this->collTrackerItemDuplicatesRelatedByTrackerItemId[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerItemTimes !== null) {
				for ($i=0,$size=count($this->collTrackerItemTimes); $i < $size; $i++) {
					if (($retval = $this->collTrackerItemTimes[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed tracker_item_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setTrackerItemId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getTrackerItemId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return TrackerItem Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new TrackerItem();
		$copyObj->setTrackerId($this->tracker_id);
		$copyObj->setStatusId($this->status_id);
		$copyObj->setPriority($this->priority);
		$copyObj->setSubmittedBy($this->submitted_by);
		$copyObj->setOpenDate($this->open_date);
		$copyObj->setCloseDate($this->close_date);
		$copyObj->setSummary($this->summary);
		$copyObj->setDetails($this->details);
		$copyObj->setLastModifiedDate($this->last_modified_date);
		$copyObj->setLastModifiedBy($this->last_modified_by);
		$copyObj->setSortOrder($this->sort_order);
		$copyObj->setParentId($this->parent_id);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getCruisecontrolDefects() as $relObj) {
				$copyObj->addCruisecontrolDefect($relObj->copy());
			}

			foreach($this->getTrackerItemScmCommits() as $relObj) {
				$copyObj->addTrackerItemScmCommit($relObj->copy());
			}

			foreach($this->getTrackerExtraFieldDatas() as $relObj) {
				$copyObj->addTrackerExtraFieldData($relObj->copy());
			}

			foreach($this->getTrackerMyQueues() as $relObj) {
				$copyObj->addTrackerMyQueue($relObj->copy());
			}

			foreach($this->getTrackerItemAssignees() as $relObj) {
				$copyObj->addTrackerItemAssignee($relObj->copy());
			}

			foreach($this->getTrackerItemMessages() as $relObj) {
				$copyObj->addTrackerItemMessage($relObj->copy());
			}

			foreach($this->getTrackerItemRelationsRelatedByRelatedTrackerItemId() as $relObj) {
				$copyObj->addTrackerItemRelationRelatedByRelatedTrackerItemId($relObj->copy());
			}

			foreach($this->getTrackerItemRelationsRelatedByTrackerItemId() as $relObj) {
				$copyObj->addTrackerItemRelationRelatedByTrackerItemId($relObj->copy());
			}

			foreach($this->getTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemId() as $relObj) {
				$copyObj->addTrackerItemDuplicateRelatedByDuplicateOfTrackerItemId($relObj->copy());
			}

			foreach($this->getTrackerItemDuplicatesRelatedByTrackerItemId() as $relObj) {
				$copyObj->addTrackerItemDuplicateRelatedByTrackerItemId($relObj->copy());
			}

			foreach($this->getTrackerItemTimes() as $relObj) {
				$copyObj->addTrackerItemTime($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setTrackerItemId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return TrackerItemPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new TrackerItemPeer();
		}
		return self::$peer;
	}

}
