<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a TrackerItem and saves it to the 
// database
//
require_once('plugins/tracker/lib/TrackerItem.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');
require_once('core/FilesystemPeer.php');
require_once('plugins/tracker/lib/TrackerItemTime.php');
require_once('plugins/tracker/lib/TrackerItemRelation.php');
require_once('plugins/tracker/lib/TrackerItemDuplicate.php');
require_once('plugins/tracker/lib/TrackerItemMessage.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

//force login
$sess = Session::getSession();
if (!$sess->isLoggedIn()) {
	throw new NotLoggedInException();
}
$Project = GFUrl::getUrl()->getProject();

$TrackerItem = TrackerItemPeer::retrieveByPk($_REQUEST['tracker_item_id']);
//validate that this is a legitimate trackeritem for this tracker and user can add items
if (!is_object($TrackerItem) 
	|| $TrackerItem->getTracker()->getProjectId() != $Project->getProjectId()
	|| !$Project->getPermission()->check(Tracker::SECTION, $TrackerItem->getTrackerId(), Tracker::PERMLEVEL_TECH)) {
	throw new PermissionDeniedException();
}

if (isset($_POST['sure'])) {

	$con = Propel::getConnection(TrackerItemPeer::DATABASE_NAME);
	$con->begin();

	$clone = $TrackerItem->copy();
	$clone = $TrackerItem->copyExtraFields($clone);
	$dup = new TrackerItemDuplicate();
	$dup->setDuplicateOfTrackerItemId($TrackerItem->getTrackerItemId());
	$clone->addTrackerItemDuplicateRelatedByTrackerItemId($dup);
	$tia = new TrackerItemAssignee();
	$tia->setAssignee(100);
	$clone->addTrackerItemAssignee($tia);
	//$clone->rebuildExtraFieldData();
	$clone->save();

	$con->commit();
	GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL('TrackerItemEdit', array('feedback' => $language->getText('TrackerItem.CloneFeedback'),'tracker_item_id'=>$clone->getTrackerItemId())));

} else {
	GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL('TrackerItemEdit', array('feedback' => $language->getText('TrackerItem.CloneDidntConfirm'),'tracker_item_id'=>$TrackerItem->getTrackerItemId())));
}

?>
