<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new TrackerExtraFieldElementTransition and saves it to the 
// database
//
require_once('plugins/tracker/lib/TrackerExtraFieldElementTransition.php');
require_once('plugins/tracker/lib/TrackerExtraFieldElementTransitionPeer.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

$Lang = Language::getSessLang();
$Project = GFUrl::getUrl()->getProject();
$TrackerExtraFieldElementTransition = TrackerExtraFieldElementTransitionPeer::retrieveByPk($_REQUEST['tracker_extra_field_element_transition_id']);
$Tracker = $TrackerExtraFieldElementTransition->getTrackerExtraFieldElementRelatedByElementId()->getTrackerExtraField()->getTracker();

$element_id=$TrackerExtraFieldElementTransition->getTrackerExtraFieldElementRelatedByElementId()->getElementId();

if (!is_object($Tracker) || !$Tracker->userIsAdmin()) {
        throw new PermissionDeniedException();
}

if (isset($_POST['sure'])) {
	$TrackerExtraFieldElementTransition->delete();
	GFUrl::redirect($url->currentBaseURL('TrackerExtraFieldElementTransitionBrowse'), array('feedback' => $Lang->getText('TrackerExtraFieldElementTransition.DeleteFeedback'),'element_id'=>$element_id));
} else {
	GFUrl::redirect($url->currentBaseURL('TrackerExtraFieldElementTransitionBrowse'), array('feedback' => $Lang->getText('TrackerExtraFieldElementTransitionDeleteForm.DidntConfirm'), 'element_id' => $element_id));
}

?>
