<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new Snippet and saves it to the 
// database
//
require_once('Validator.php');
require_once('exceptions/InvalidDataException.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');
require_once('core/Filesystem.php');

Validator::validatePOSTAction();

$user = GFUrl::getUrl()->getUser();

$Lang = Language::getSessLang();
$errors = array();

try {
	
	$filename=$_FILES['addfile']['name'];
	$tmp_name=$_FILES['addfile']['tmp_name'];
	if (!is_uploaded_file($tmp_name)) {
		$feedback = 'Error uploading file';
	} else {
		$size=$_FILES['addfile']['size'];
		$type=$_FILES['addfile']['type'];

		$fs = new Filesystem();
		$fs->setSection(User::SECTION);
		$fs->setRefId($user->getUserId());

		$fs->setFileName( $filename );
		$fs->setFileType( $type );
		$fs->setFileSize( $size );
		$fs->setPostedBy( $user->getUserId() );
		$fs->save();
		$fs->setFileDataFromPath( $tmp_name );
		$feedback = 'File added';
	}
	
	GFUrl::redirect(GFUrl::getUrl()->currentBaseURL('index.php'), array('feedback' => $feedback));
} catch (InvalidDataException $ex) {
	$errors = array_merge($errors, $ex->getErrors());		// attach object errors to validation errors
	$feedback = '* '.implode('<br />* ', $errors);
	include('userfileAdd.php');

}
?>
