<?php
/**
 * Copyright (c) 2006 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * ## GFORGE GROUP LICENSE TERMS ##
 */
//
// This code lists WikiPage
//
require_once('plugins/wiki/lib/WikiPagePeer.php');
require_once('plugins/wiki/lib/WikiPage.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/wiki/lib/html/WikiTemplate.php');
$theme = new WikiTemplate();

$Project = GFUrl::getUrl()->getProject();

$section = Project::SECTION;
$ref_id = $Project->getProjectId();

$wiki = new Wiki($section,$ref_id,$theme,$Project);

$params = array(
		'project' => $Project,
	//	'WikiTemplate' => $WikiTemplate,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('WikiPage.BrowsePageTitle'),
		'wiki' => $wiki
		);
$theme->header($params);


// Retrieve the objects array
$crit = new Criteria();
$crit->add(WikiPagePeer::REF_ID, $Project->getProjectId());
$crit->add(WikiPagePeer::SECTION, Project::SECTION);
$arr = WikiPagePeer::doSelect($crit);

$theader = array();

$theader[] = $Lang->getText('WikiPage.WikiPageIdName');
$theader[] = $Lang->getText('WikiPage.PagenameName');
$theader[] = $Lang->getText('WikiPage.FlagsName');
$theader[] = $Lang->getText('Edit');
$theader[] = $Lang->getText('Delete');

echo $theme->tableTop($theader);

if (count($arr) < 1) {
	echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('WikiPage.NoneFound').'</span>');
} else {
	foreach ($arr as $item) {
		$trow = array();
		$trow[]=$item->getWikiPageId();
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('').'?pagename='.urlencode($item->getPageName()) .'">'.$item->getPagename().'</a>';
		$itemadmin = $item->userIsAdmin();
		$itemedit = $item->userCanUpdate();
		if($itemadmin) {
			$trow[]=(($item->getFlags()) ? '<img alt="(locked)" src="/images/locked.png">&nbsp;<a href="'. GFUrl::getUrl()->projectUrl($Project,'UnlockPage','wiki','admin',array('unlock'=>$item->getWikiPageId())).'">'. $Lang->getText('Wiki.Unlock') .'</a>' : '<a href="'. GFUrl::getUrl()->projectUrl($Project,'LockPage','wiki','admin',array('lock'=>$item->getWikiPageId())).'">'. $Lang->getText('Wiki.Lock') .'</a>' );
		} else {
			$trow[]=(($item->getFlags()) ? '<img alt="(locked)" src="/images/locked.png">&nbsp;':'' );
		}
		
		if($itemedit && !$item->getFlags()) {
			$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('PageEdit').'&amp;edit='.urlencode($item->getPageName()) .'">'. $Lang->getText('Edit') .'</a>';
		} else {
			$trow[]='&nbsp;';
		}
		
		if($itemadmin && ($item->getPageName() != 'FrontPage') && !$item->getFlags()) {
			$trow[]='<a href="'. GFUrl::getUrl()->projectUrl($Project,'RemovePage','wiki','admin',array('remove'=>$item->getWikiPageId(), 'pagename'=>$item->getPageName())).'">'. $Lang->getText('Delete') .'</a>';
		} else {
			$trow[]='&nbsp;';
		}

		echo $theme->tableRow($trow, array(), false);
	}
}

echo $theme->tableBottom();

$theme->footer($params);

?>

